Up

# NSEvent

### Authors

Scott Christley (`scottc@net-community.com`)
Ovidiu Predescu (`ovidiu@net-community.com`)
Felipe A. Rodriguez (`far@ix.netcom.com`)

> The event class

Copyright: (C) 1996 Free Software Foundation, Inc.

# Software documentation for the NSEvent class

## NSEvent : NSObject

> Declared in:
>   AppKit/NSEvent.h

> Conforms to:
>   NSCoding
>   NSCopying

> Standards:
> - MacOS-X
> - OpenStep
> - GNUstep

Description forthcoming.

Method summary

- +enterExitEventWithType:location:modifierFlags:timestamp:windowNumber:context:eventNumber:trackingNumber:userData:
- +keyEventWithType:location:modifierFlags:timestamp:windowNumber:context:characters:charactersIgnoringModifiers:isARepeat:keyCode:
- +mouseEventWithType:location:modifierFlags:timestamp:windowNumber:context:eventNumber:clickCount:pressure:
- +mouseEventWithType:location:modifierFlags:timestamp:windowNumber:context:eventNumber:clickCount:pressure:buttonNumber:deltaX:deltaY:deltaZ:
- +mouseLocation
- +otherEventWithType:location:modifierFlags:timestamp:windowNumber:context:subtype:data1:data2:
- +startPeriodicEventsAfterDelay:withPeriod:
- +stopPeriodicEvents
- -buttonNumber
- -characters
- -charactersIgnoringModifiers
- -clickCount
- -context
- -data1
- -data2
- -deltaX
- -deltaY
- -deltaZ
- -eventNumber
- -isARepeat
- -keyCode
- -locationInWindow
- -modifierFlags
- -pressure
- -subtype
- -timestamp
- -trackingNumber
- -type
- -userData
- -window
- -windowNumber

### enterExitEventWithType:location:modifierFlags:timestamp:windowNumber:context:eventNumber:trackingNumber:userData:

+ (NSEvent*) enterExitEventWithType: (NSEventType)type location: (NSPoint)location modifierFlags: (unsigned int)flags timestamp: (NSTimeInterval)time windowNumber: (int)windowNum context: (NSGraphicsContext*)context eventNumber: (int)eventNum trackingNumber: (int)trackingNum userData: (void*)userData;

Description forthcoming.

### keyEventWithType:location:modifierFlags:timestamp:windowNumber:context:characters:charactersIgnoringModifiers:isARepeat:keyCode:

+ (NSEvent*) keyEventWithType: (NSEventType)type location: (NSPoint)location modifierFlags: (unsigned int)flags timestamp: (NSTimeInterval)time windowNumber: (int)windowNum context: (NSGraphicsContext*)context characters: (NSString*)keys charactersIgnoringModifiers: (NSString*)ukeys isARepeat: (BOOL)repeatKey keyCode: (unsigned short)code;

Description forthcoming.

### mouseEventWithType:location:modifierFlags:timestamp:windowNumber:context:eventNumber:clickCount:pressure:

+ (NSEvent*) mouseEventWithType: (NSEventType)type location: (NSPoint)location modifierFlags: (unsigned int)flags timestamp: (NSTimeInterval)time windowNumber: (int)windowNum context: (NSGraphicsContext*)context eventNumber: (int)eventNum clickCount: (int)clickNum pressure: (float)pressureValue;

Description forthcoming.

### mouseEventWithType:location:modifierFlags:timestamp:windowNumber:context:eventNumber:clickCount:pressure:buttonNumber:deltaX:deltaY:deltaZ:

+ (NSEvent*) mouseEventWithType: (NSEventType)type location: (NSPoint)location modifierFlags: (unsigned int)flags timestamp: (NSTimeInterval)time windowNumber: (int)windowNum context: (NSGraphicsContext*)context eventNumber: (int)eventNum clickCount: (int)clickNum pressure: (float)pressureValue buttonNumber: (int)buttonNum deltaX: (float)deltaX deltaY: (float)deltaY deltaZ: (float)deltaZ;

Description forthcoming.

### mouseLocation

+ (NSPoint) mouseLocation;

Returns the current mouse location.

### otherEventWithType:location:modifierFlags:timestamp:windowNumber:context:subtype:data1:data2:

+ (NSEvent*) otherEventWithType: (NSEventType)type location: (NSPoint)location modifierFlags: (unsigned int)flags timestamp: (NSTimeInterval)time windowNumber: (int)windowNum context: (NSGraphicsContext*)context subtype: (short)subType data1: (int)data1 data2: (int)data2;

Description forthcoming.

### startPeriodicEventsAfterDelay:withPeriod:

+ (void) startPeriodicEventsAfterDelay: (NSTimeInterval)delaySeconds withPeriod: (NSTimeInterval)periodSeconds;

Description forthcoming.

### stopPeriodicEvents

+ (void) stopPeriodicEvents;

Description forthcoming.

### buttonNumber

- (int) buttonNumber;

Returns the button number for the mouse button pressed in a mouse event. Intended primarily for the case where a mouse has three or more buttons, and you want to know which button an 'other' mouse event refers to.

### characters

- (NSString*) characters;

Returns the string of characters for a keyboard event.
Raises an NSInternalInconsistencyException if applied to any other type of event.

### charactersIgnoringModifiers

- (NSString*) charactersIgnoringModifiers;

Returns the string of characters for a keyboard event, as if no modifier keys had been pressed when the keyboard event occirred.
Raises an NSInternalInconsistencyException if applied to any other type of event.

### clickCount

- (int) clickCount;

Return the number of clicks associated with the mouse down or up event. This method is not applicable for any event type other than a mouse down or mouse up.
Raises an NSInternalInconsistencyException if applied to any other type of event.

### context

- (NSGraphicsContext*) context;

Returns the graphics context for which this event was generated.

### data1

- (int) data1;

Returns the 'data1' item associated with the event.
Raises NSInternalInconsistencyException if the event is not of type NSAppKitDefined, NSSystemDefined, NSApplicationDefined, or NSPeriodic

### data2

- (int) data2;

Returns the 'data2' item associated with the event.
Raises NSInternalInconsistencyException if the event is not of type NSAppKitDefined, NSSystemDefined, NSApplicationDefined, or NSPeriodic

### deltaX

- (float) deltaX;

Returns the movement of the mouse on the X axis.

This method is only valid for NSMouseMoved, NS*MouseDragged and NSScrollWheel events, otherwise it will raise an NSInternalInconsistencyException.

### deltaY

- (float) deltaY;

Returns the movement of the mouse on the Y axis.

This method is only valid for NSMouseMoved, NS*MouseDragged and NSScrollWheel events, otherwise it will raise an NSInternalInconsistencyException.

### deltaZ

- (float) deltaZ;

Returns the movement of the mouse on the Z axis.

This method is only valid for NSMouseMoved, NS*MouseDragged and NSScrollWheel events, otherwise it will raise an NSInternalInconsistencyException.

The value returned is 0.0 in most cases.

### eventNumber

- (int) eventNumber;

Returns the event number associated with any mouse event or tracking event. Event numbers are allocated sequentially when the system creates these events.
Raises an NSInternalInconsistencyException if applied to any other type of event.

### isARepeat

- (BOOL) isARepeat;

Returns a flag to say if this is a keyboard repeat event.
Raises an NSInternalInconsistencyException if applied to any other type of event than an NSKeyUp or NSKeyDown.

### keyCode

- (unsigned short) keyCode;

Returns the numeric key code of a keyboard event.
Raises an NSInternalInconsistencyException if applied to any other type of event than an NSKeyUp or NSKeyDown.

### locationInWindow

- (NSPoint) locationInWindow;

Returns the window location for which this event was generated (in the base coordinate system of the window).

### modifierFlags

- (unsigned int) modifierFlags;

Returns the modifier flag bits associated with the event.

### pressure

- (float) pressure;

Returns the pressure associated with a mouse event. This is a value in the range 0.0 to 1.0 and for mormal mouse events should be set to one of those extremes. This is used by pressure sensitive input devices.
Raises an NSInternalInconsistencyException if applied to any other type of event than a mouse event.

### subtype

- (short) subtype;

Returns the 'subtype' item associated with the event.
Raises NSInternalInconsistencyException if the event is not of type NSAppKitDefined, NSSystemDefined, NSApplicationDefined, or NSPeriodic

### timestamp

- (NSTimeInterval) timestamp;

Returns the time interval since system startup at which this event was generated.

### trackingNumber

- (int) trackingNumber;

Returns a number identifying the tracking rectangle entered or exited.
Raises an NSInternalInconsistencyException if applied to any other type of event than a mouse entered or exited event.

### type

- (NSEventType) type;

returns the type of this event.

### userData

- (void*) userData;

Returns usder data associated with a tracking event... the data assigned to the tracking rectangle concerned when it was created..
Raises an NSInternalInconsistencyException if applied to any other type of event than a mouse entered or exited event.

### window

- (NSWindow*) window;

Returns the window for which this event was generated.
Periodic events have no associated window, and you should not call this method for those events.

### windowNumber

- (int) windowNumber;

Returns the window number of the window for which this event was generated.
Periodic events have no associated window, and you should not call this method for those events.

Up